

; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

#define MyAppName "XYZ"
#define MyAppURL "http://www.XYZ.com/"
#define MyAppExeName "XYZ.accde"

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{1FDC7F46-FCEC-4019-95BE-944F030F7094}
AppName={#MyAppName}
AppVersion={#MyAppVersion}
;AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
DefaultDirName=C:\{#MyAppName}
DisableDirPage=yes
DefaultGroupName={#MyAppName}
AllowNoIcons=yes
LicenseFile=Z:\XYZ\Nutzungbedingungen 01 2012.rtf
OutputDir=Z:\XYZ\Inno Setup\TM Demo
OutputBaseFilename=setup
SetupIconFile=Z:\XYZ\Logo\XYZ.ico
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "Z:\XYZ\Inno Setup\Default.isl"
Name: "de"; MessagesFile: "Z:\XYZ\Inno Setup\German.isl"

;http://www.sherlocksoftware.org/page.php?id=50
#include ReadReg(HKEY_LOCAL_MACHINE,'Software\Sherlock Software\InnoTools\Downloader','ScriptPath','');

[CustomMessages]
english.Nowinstall=Setup will now install Access 2007 Runtime.
de.Nowinstall=Das Setup wird nun die integrierte Access 2007 Runtime installieren.
english.continue_install=To continue press [OK]!
de.continue_install=Klicken Sie auf [OK], um fortzufahren.
english.complete_install=Access-Runtime 2010 has been successfully installed.
de.complete_install=Die Access-Runtime 2010 wurde erfolgreich installiert.     
english.no_runtime=Setup will now download the free Microsoft Access Runtime 2010 which is required to run the XYZ.%n%nPlease make sure you are connected to the internet.
de.no_runtime=Das Setup ldt jetzt die kostenlose Microsoft Access Runtime 2010 herunter und installiert sie anschlieend.%n%nDie Runtime ist fr die Nutzung des XYZs unbedingt erforderlich.%n%nBitte bleiben Sie mit dem Internet verbunden.                            


[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"

#include <idp.iss> 
   
[Files]
Source: "Z:\XYZ\XYZ.com DEMO\XYZ.accde"; DestDir: "{app}"; Flags: ignoreversion
Source: "Z:\XYZ\DEMO mit Access DB\XYZ_database.accdb"; DestDir: "{app}"; Flags: ignoreversion onlyifdoesntexist uninsneveruninstall
Source: "Z:\XYZ\Logo\XYZ.ico"; DestDir: "{app}"; Flags: ignoreversion 
Source: "Z:\XYZ\XYZ.com DEMO\AddPath2010.exe"; DestDir: "{app}"; Flags: ignoreversion


[Icons]
Name: "{group}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}";Parameters: /runtime; IconFilename: {app}\XYZ.ico
Name: "{commondesktop}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}"; Parameters: /runtime; IconFilename: {app}\XYZ.ico

[Run]
;Filename: "{tmp}\AccessRuntime.exe"
Filename: "{app}\XYZ.accde"; Parameters: /runtime; Description: "{cm:LaunchProgram}"; Flags: shellexec postinstall skipifsilent

[Code]

var
  NoRuntimePage: TOutputMsgWizardPage;
  Access2010DetectedPage: TOutputMsgWizardPage;
  NeedsRuntime: Boolean;
  InstalledRuntime: Boolean;
  Access2010Detected: Boolean;

//---------------------------------------------------------------------

procedure InitializeWizard();
var
localAccess: String;
localAccess2: String;
msg_runtime: String;
begin
 NeedsRuntime := True
 // Create page for when Runtime is needed to be installed
 msg_runtime := CustomMessage('no_runtime')
 NoRuntimePage := CreateOutputMsgPage(wpWelcome,
 'Information', '', CustomMessage('no_runtime'));
 // Create page for when Access 2007 is detected
 Access2010DetectedPage := CreateOutputMsgPage(wpWelcome,
 'Information', 'Please read the following.',
 'Setup has detected that you have MSAccess 2007 installed on this system' #13#13 +
 '-= CHANGE THIS MYAPP CHANGE THIS=- was designed to work with MSAccess 2003 and therefore some functions may not appear to work correctly' #13#13 +
 'Please dont hesitate to contact us if you have any proplems');

 //initialise download module and set which files may need to be downloaded
 //
 //CHANGE WEB ADDRESS
 //
 itd_init;
 itd_addfile('http://www.XYZ.com/downloads/AccessRuntime.exe',expandconstant('{tmp}\AccessRuntime.exe'));
 // itd_addfile('http://www.myapp.com/ACCESSRT.CAB',expandconstant('{tmp}\ACCESSRT.CAB'));

 //Check if Access 2010 is installed
Access2010Detected := False
NeedsRuntime := True
InstalledRuntime := False
    RegQueryStringValue( HKEY_LOCAL_MACHINE,'SOFTWARE\Wow6432Node\Microsoft\Office\14.0\Access\InstallRoot','Path',localAccess );
	if fileexists(localAccess + '\MsAccess.exe') then begin //Access 2010
		NeedsRuntime := False
		Access2010Detected := False
		end;
    if NeedsRuntime=True then //No Access 2010
			itd_downloadafter(NoRuntimePage.ID); //Download Runtime Install Files
end;

//------------------------

//		If Runtime Download is not needed, skip the warning page
Function ShouldSkipPage(PageID: Integer): Boolean;
begin
	If (PageID = NoRuntimePage.ID) then begin
		if NeedsRuntime=False then
			Result := True
		else Result := False
	end;

	If (PageID = Access2010DetectedPage.ID) then begin
		if Access2010Detected=False then
			Result := True
		else Result := False
	end;
end;

//------------------------------------------------------------------------

//Install Runtime after downloaded if needed
procedure CurStepChanged(CurStep: TSetupStep);
var
resultcode: Integer;
begin
	if CurStep=ssInstall then begin
		if NeedsRuntime=True then begin
			// if Exec('msiexec.exe', '/i "' + ExpandConstant('{tmp}\AccessRuntime.exe') + '" /qb REBOOT=ReallySuppress"', '', SW_SHOW, ewWaitUntilTerminated, ResultCode) then
			 if ShellExec('',ExpandConstant('{tmp}\AccessRuntime.exe'), '','', SW_SHOW, ewWaitUntilTerminated, ResultCode)	  then
        InstalledRuntime := True
			else
//
//CHANGE EMAIL ADDRESS IN NEXT LINE
//
				msgbox ('Access 2010 Runtime has failed to install!' #13#13 'Please contact us at info@XYZ.com for help installing',mbInformation, MB_OK);
		end;
	end;

	if CurStep=ssPostInstall then begin
		if InstalledRuntime=True then begin
			filecopy(expandconstant('{tmp}\AccessRuntime.exe'),expandconstant('{app}\AccessRuntime.exe'),false)
			deletefile('{tmp}\AccessRuntime.exe')
			// deletefile('{tmp}\AccessRT.CAB')
		end;
	end;
end;
